Перейти к основному содержимому

Связь данных и управление состоянием в Angular Gantt

Angular Gantt поддерживает две модели владения данными:

  1. Состояние Angular / хранение как источник истины (рекомендуется для большинства приложений).
  2. Gantt как источник истины (ориентировано на производительность для специализированных страниц).

Выбирайте одну модель на страницу/область функционала и соблюдайте её единообразно.

Состояние Angular или хранилище как источник истины

В этой модели:

  • состояние вашего компонента или RxJS‑хранилища владеют tasks и links,
  • обёртка получает массивы через входы,
  • изменения графика фиксируются через data.save или data.batchSave,
  • коллбэки обновляют ваше состояние/хранилище, и новые массивы возвращаются в <dhx-gantt>.

Лучшее применение

  • страницы Angular с панелями инструментов и формами, которые должны оставаться синхронизированными с графиком,
  • кодовые базы команд, уже построенные на сервисах и RxJS,
  • предсказуемые переходы состояния и упрощенная отладка.

Преимущества и недостатки

  • больше обновлений состояния приложения для тяжелых операций с графиком,
  • более частая работа по синхронизации при массовом редактировании.

Антишаблоны, которых следует избегать

  • изменение данных через instance, при этом отправляя устаревшие массивы tasks/links из состояния Angular,
  • игнорирование data.save / data.batchSave и ожидание, что редактирования графика будут автоматически сохраняться в состоянии вашего приложения.

Полный пример потока (состояние компонента)

import { Component } from '@angular/core';
import {
DhxGanttComponent,
type AngularGanttDataConfig,
type SerializedTask,
type SerializedLink,
} from '@dhtmlx/trial-angular-gantt';

@Component({
standalone: true,
imports: [DhxGanttComponent],
template: `<dhx-gantt [tasks]="tasks" [links]="links" [data]="dataConfig"></dhx-gantt>`,
})
export class GanttPageComponent {
tasks: SerializedTask[] = [];
links: SerializedLink[] = [];

dataConfig: AngularGanttDataConfig = {
save: (entity, action, item, id) => {
if (entity === 'task') {
if (action === 'create') this.tasks = [...this.tasks, item];
if (action === 'update') this.tasks = this.tasks.map((t) => String(t.id) === String(id) ? { ...t, ...item } : t);
if (action === 'delete') this.tasks = this.tasks.filter((t) => String(t.id) !== String(id));
}

if (entity === 'link') {
if (action === 'create') this.links = [...this.links, item];
if (action === 'update') this.links = this.links.map((l) => String(l.id) === String(id) ? { ...l, ...item } : l);
if (action === 'delete') this.links = this.links.filter((l) => String(l.id) !== String(id));
}
},
};
}

Gantt как источник истины

В этой модели график и бэкэнд владеют большей частью жизненного цикла данных во время выполнения.

Лучшее применение

  • очень больших наборов данных,
  • экранов, ориентированных на график,
  • тяжелого автоматического планирования или цепочечных редактирований, где частые обновления в приложении дороги.

Преимущества и недостатки

  • менее очевидная видимость текущего состояния графика в сервисах/компонентах Angular,
  • требуется дополнительная дисциплина при смешивании редких обновлений входов с императивными операциями.

Антишаблоны, которых следует избегать

  • частичное зеркалирование без четкого плана согласования,
  • повторная подача устаревших снимков сервера после того, как пользователи уже изменили данные в графике.

Пример серверного транспорта

dataConfig = {
load: '/api/gantt/load',
save: async (entity: string, action: string, payload: any, id: string | number) => {
const response = await fetch(`/api/gantt/${entity}`, {
method: action === 'delete' ? 'DELETE' : 'POST',
headers: { 'Content-Type': 'application/json' },
body: JSON.stringify({ action, payload, id }),
});

return await response.json();
},
};

Используйте это, когда бэкенд является источником истины состояния и Angular не требуется зеркально отражать каждое редактирование в реальном времени.

Контракты обратного вызова

data.save

save передается в gantt.createDataProcessor(save) и получает данные изменений.

Типичная сигнатура функции:

(entity: string, action: string, data: any, id: string | number) => any

Используйте это, когда изменения в основном единичны и легко применяются по одному.

data.batchSave

batchSave получает сгруппированные данные изменений:

interface BatchChanges {
tasks?: DataCallbackChange[];
links?: DataCallbackChange[];
resources?: DataCallbackChange[];
resourceAssignments?: DataCallbackChange[];
}

Соответствие сущности к bucket включает:

  • task / tasks -> tasks
  • link / links -> links
  • resource / resources -> resources
  • assignment / resourceAssignment / resourceAssignments -> resourceAssignments

Краткое описание поведения очереди:

  • небольшая пакетная обработка с дребезгом (debounce),
  • create + update объединены в один create с последними данными,
  • create + delete удалены,
  • внутренний !nativeeditor_status удаляется из полезных нагрузок.

Используйте это, когда одно действие графика может инициировать множество последующих изменений.

Загрузка данных в состояние Angular

Локальное состояние компонента

Используйте локальные поля компонента для небольших страниц или прототипов.

Загружайте данные в Angular, затем присваивайте массивы входам tasks и links. Обработчики обратного вызова держите в том же компоненте.

RxJS‑сервисы / хранилища (рекомендуется для приложений среднего и крупного размера)

Используйте внедряемый сервис с BehaviorSubject (или аналогом) для хранения задач, ссылок и состояния UI.

Это паттерн, используемый в открытом примере Angular и документированный в Using Angular Gantt with RxJS.

Загрузка из API в состояние Angular

Типичный поток:

  1. Получайте данные в сервисе или разрешителе маршрута.
  2. Нормализуйте или сопоставляйте форматы дат при необходимости.
  3. Поместите данные в ваше хранилище/состояние компонента.
  4. Передайте массивы в <dhx-gantt>.
  5. Обрабатывайте редактирования с data.save или data.batchSave и сохраняйте в backend.

Используйте это, когда состояние Angular является источником истины, а бэкенд по-прежнему служит долгосрочным источником данных.

Gantt как источник истины в приложении Angular

Когда эта модель имеет смысл

Выберите это, когда страница в основном состоит из графика и окружающий UI Angular не требует реагировать на каждое обновление задачи/ссылки.

Предоставление исходных данных

Вы можете инициализировать данные, управляемые Gantt, любым из следующих шаблонов:

  • data.load URL
  • data.load функция (синхронная или асинхронная)
  • начальные массивы tasks/links, затем перестаньте рассматривать их как живые входы источника истины

Как работают обновления

Экземпляр Gantt применяет изменения пользователя локально и отправляет их через save или batchSave.

Angular не нужно переназначать tasks/links после каждого изменения, если вы явно не хотите их зеркально отражать.

Перепривязка ID и ответственность бэкенда

Создание действий часто начинается с временных клиентских ID.

  • В режиме save ответы бэкенда должны возвращать постоянные IDs, чтобы Gantt мог выполнить переназначение внутренних записей.
  • В режиме batchSave нет пути возврата на уровне элементов, поэтому переназначение ID должно обрабатываться явно в вашем процессе сохранения, если бэкенд присваивает новые IDs.

Бэкенд остается ответственным за:

  • валидацию,
  • проверки разрешений,
  • постоянное присвоение ID,
  • согласованные полезные нагрузки ответов.

Продолжение

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Перейти к основному содержимому

Связь данных и управление состоянием во Vue Gantt

Это руководство поможет вам выбрать, где ваше приложение владеет данными Gantt и как поддерживать синхронизацию правок на диаграмме. Выберите одну модель владения на каждой странице и придерживайтесь её.

Vue Gantt поддерживает две распространённые модели:

  1. Vue-состояние или хранилище как источник истины (лучший выбор по умолчанию для большинства приложений)
  2. Gantt как источник истины (ориентирована на производительность для страниц с большим количеством диаграмм)

Ментальная модель

Обёртка синхронизирует пропсы с активным экземпляром Gantt. Если пользователи редактируют данные на диаграмме, вы решаете, следует ли:

  • обработчик обёртки обновляет состояние Vue (модель, управляемая Vue), или
  • график/бэкэнд обрабатывает изменения напрямую (модель, управляемая Gantt)

Основная ловушка — смешанное владение. Если Vue и экземпляр Gantt одновременно выступают как источник правды, велика вероятность перезаписи устаревших данных.

Vue-состояние или хранилище как источник истины

В этой модели:

  • Состояние Vue (или Pinia) владеет tasks и links
  • обёртка получает массивы через пропсы
  • правки диаграммы фиксируются через data.save или data.batchSave
  • обработчики колбэков обновляют состояние
  • обновлённое состояние возвращается во внешнюю обёртку

Рекомендованный тип для этой модели: используйте SerializedTask[] и SerializedLink[] для реактивных массивов состояния.

Best For

  • страницы с окружающим Vue UI, которые должны отражать состояние диаграммы
  • приложения, которые уже используют Pinia или централизованный слой состояния
  • команды, которым нужна предсказуемая однонаправленная передача данных

Tradeoffs

  • больше обновлений состояния приложения при тяжёлых операциях
  • больше работы по синхронизации, когда много правок выполняется в одном действии диаграммы

Avoid These Patterns

  • изменение данных задач/ссылок через instance, при этом продолжение передачи устаревших массивов из состояния Vue
  • игнорирование колбэков обёртки и ожидание, что правки диаграммы автоматически сохранятся в состоянии Vue

Пример: Store/Vue- owned Flow

<script setup lang="ts">
import { ref } from "vue";
import VueGantt, {
type SerializedLink,
type SerializedTask,
type VueGanttDataConfig
} from "@dhtmlx/trial-vue-gantt";

const tasks = ref<SerializedTask[]>([]);
const links = ref<SerializedLink[]>([]);

const data: VueGanttDataConfig = {
save: (entity, action, item, id) => {
if (entity === "task") {
if (action === "create") tasks.value = [...tasks.value, item as SerializedTask];
if (action === "update") tasks.value = tasks.value.map(t => String(t.id) === String(id) ? item as SerializedTask : t);
if (action === "delete") tasks.value = tasks.value.filter(t => String(t.id) !== String(id));
}

if (entity === "link") {
if (action === "create") links.value = [...links.value, item as SerializedLink];
if (action === "update") links.value = links.value.map(l => String(l.id) === String(id) ? item as SerializedLink : l);
if (action === "delete") links.value = links.value.filter(l => String(l.id) !== String(id));
}
}
};
</script>

<template>
<VueGantt :tasks="tasks" :links="links" :data="data" />
</template>

Для операций с несколькими изменениями перейдите к data.batchSave и применяйте изменения пакетами.

Gantt как источник истины

В этой модели график и бэкенд управляют большинством жизненных циклов данных. Vue выполняет меньшее живое отражение.

Best For

  • очень большие наборы данных
  • интенсивное автоматическое планирование или потоки массового обновления
  • страницы, ориентированные на диаграмму, где внешнее UI не требует видеть каждое живое изменение немедленно

Tradeoffs

  • меньше видимости текущего состояния диаграммы в состоянии Vue/хранилища
  • требуется больше дисциплины, если иногда вы возвращаете снимки пропсов во внешний обёртку

Avoid These Patterns

  • частичное зеркалирование Vue без стратегии согласования
  • повторная загрузка устаревших снимков сервера после редактирования диаграммы пользователями

Пример: поток владения Gantt

<script setup lang="ts">
import VueGantt from "@dhtmlx/trial-vue-gantt";

const data = {
load: "/api/gantt/load",
save: async (entity: string, action: string, payload: any, id: string | number) => {
const response = await fetch(`/api/gantt/${entity}`, {
method: action === "delete" ? "DELETE" : "POST",
headers: { "Content-Type": "application/json" },
body: JSON.stringify({ action, payload, id })
});

// Созданные обработчики должны возвращать постоянный ID, если бэкенд переотмечает его.
return await response.json();
}
};
</script>

<template>
<VueGantt :data="data" />
</template>

Контракты колбеков

Этот раздел охватывает формы колбеков обёртки, которые вы используете в обеих моделях владения.

data.save

save передаётся в gantt.createDataProcessor(save) и принимает одно изменение за раз.

Типичная форма функции:

(entity: string, action: string, data: any, id: string | number) => any

Используйте это, когда изменения в основном одиночные и их легко обрабатывать по одному.

data.batchSave

batchSave принимает изменения, сгруппированные в четыре корзины, по одному типу данных:

interface BatchChanges {
tasks?: DataCallbackChange[];
links?: DataCallbackChange[];
resources?: DataCallbackChange[];
resourceAssignments?: DataCallbackChange[];
}

Перебирайте те корзины, которые вам важны — обёртка заполняет их автоматически из событий изменений Gantt.

Кратко о поведении очереди:

  • пакетирование на ближайшем этапе выгрузки
  • create + update можно свести в один create с последней нагрузкой
  • create + delete можно исключить из пакета
  • внутренний !nativeeditor_status удаляется из полезной нагрузки

Используйте это, когда одно действие пользователя может привести к множеству обновлений (например, авто-планирование).

Переназначение идентификаторов и ответственность бэкенда

Действия создания часто начинаются с временных идентификаторов на стороне клиента.

  • В режиме save ответы бэкенда должны возвращать постоянные идентификаторы, чтобы Gantt мог выполнить повторное отображение записей.
  • В режиме batchSave пути возвращения по элементу нет. Если сервер присваивает идентификаторы, явно обрабатывайте переназначение в вашем процессе сохранения.

Ответственность бэкенда остаётся неизменной в обоих режимах:

  • валидировать входящие полезные нагрузки
  • приводить в исполнение разрешения
  • сохранять авторитативные идентификаторы
  • возвращать структуры данных, которые ожидает выбранный вами транспортный режим

Что читать дальше

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.

Перейти к основному содержимому

Привязка данных и управление состоянием в React Gantt

React Gantt поддерживает две модели привязки данных:

  1. React state как источник истины - рекомендуется для большинства React-приложений.
  2. Gantt как источник истины - полезно для специализированных случаев.

Обе подхода допустимы, но следует выбрать один и придерживаться его последовательно, чтобы избежать непредвидимого поведения.

Эта статья объясняет оба режима и приводит базовые примеры каждого из них.

Если вы еще не отрендерили базовый график, начните с Быстрого старта.

Модели данных

React state как источник истины (рекомендуется)

В этой модели:

  • вы храните tasks, links, resources, resourceAssignments в состоянии React или в библиотеке состояний
  • передаете их в <Gantt> как props
  • когда пользователь что-то меняет, ReactGantt вызывает ваш колбэк data.save или data.batchSave
  • вы обновляете состояние React -> React перерисовывает компонент -> ReactGantt повторно читает новые props

Это правильный выбор, если на вашей странице есть другой React UI, которому нужно видеть те же данные, что и у Gantt, и если ваше приложение содержит дополнительные React-компоненты или использует менеджер состояний, который опирается на те же данные.

Однако это потребует более частого повторного разбора или перерисовки Gantt.

Gantt как источник истины

В этом подходе вы считаете ReactGantt и ваш бэкенд основными владельцами данных:

  • ReactGantt загружает начальный набор данных через data.load, или через props, или через императивный вызов API
  • ReactGantt применяет изменения пользователя внутри и/или отправляет их на сервер
  • вы не держите зеркальную копию всех задач/ссылок в состоянии React, которая постоянно возвращается в props

Ключевое различие — отсутствие полного цикла. Изменения пользователя не обновляют состояние React, и React не повторно применяет обновленные props после каждого изменения.

Эта модель полезна, когда наборы данных очень велики, так как снижает накладные расходы на постоянное обновление состояния React при изменении данных Gantt и упрощает массовые операции (как авто-расписание) без повторных перерисовок.

С другой стороны, вы теряете прямую синхронизацию между данными Gantt и вашим состоянием React. И если вы храните задачи/ссылки в состоянии React, нужно быть осторожным, чтобы не перезаписать внутреннее состояние Gantt по ошибке.

React state как источник истины

В этом шаблоне вы держите все основные коллекции в состоянии и передаёте их как пропсы (tasks, links, resources, resourceAssignments). Всякий раз, когда пользователь изменяет задачи или ссылки внутри Gantt (например, создаёт или удаляет задачу), Gantt вызывает обработчик. В этом обработчике вы обновляете своё состояние React новыми или удалёнными данными. Как только состояние обновлено, React повторно отрисовывает компонент ReactGantt, который, в свою очередь, читает обновлённые пропсы из последнего состояния.

При типизации состояния используйте SerializedTask для задач и SerializedLink для ссылок. Эти типы представляют формату данных, с которым работает пользователь — поля даты принимают Date | string, и отсутствуют внутренние свойства с префиксом $. Используйте Task и Link только при работе с данными внутри обработчиков событий Gantt, где данные уже распарсены Gantt.

Минимальный пример с React state

import { useState } from 'react';
import Gantt, {
Task,
Link
} from "@dhtmlx/trial-react-gantt";
import "@dhtmlx/trial-react-gantt/dist/react-gantt.css";

import { demoData } from "./demoData";

export default function ReactStateGantt() {
const [tasks, setTasks] = useState<Task[]>(demoData.tasks);
const [links, setLinks] = useState<Link[]>(demoData.links);


return (
<div style={{ height: "100vh" }}>
<Gantt
tasks={tasks}
links={links}
data={{
save: (entity, action, item, id) => {
// Update React state here (see below for patterns)
console.log("Change:", { entity, action, id, item });
},
}}
/>
</div>
);
}

Это даёт базовую отправную точку — React управляет тем, что рендерится через props, Gantt сообщает об изменениях через колбэк save и делает React законным владельцем данных.

Следующие разделы показывают типичные паттерны, которые реализуются внутри этого колбэка.

Обработка изменений с data.save

Когда вы передаете data.save, ReactGantt вызывает его для каждого изменения, которое пользователь делает:

(entity: string, action: string, item: any, id: string|number) => {...}

Где:

  • entity равно "task" | "link" | "resource" | "resourceAssignment"
  • action равно "create" | "update" | "delete"
  • item — созданный/обновленный/удаленный объект
  • id — идентификатор объекта

Вот простой пример, который напрямую обновляет состояние React:

function handleSave(entity, action, item, id) {
if (entity === "task") {
setTasks((prev) => {
if (action === "create") return [...prev, item];
if (action === "update") return prev.map((t) => (t.id === id ? item : t));
if (action === "delete") return prev.filter((t) => t.id !== id);
return prev;
});
}

if (entity === "link") {
setLinks((prev) => {
if (action === "create") return [...prev, item];
if (action === "update") return prev.map((l) => (l.id === id ? item : l));
if (action === "delete") return prev.filter((l) => l.id !== id);
return prev;
});
}

// При необходимости можно применить ту же идею для resources / resourceAssignments
}

В реальном приложении вы почти никогда не держите эту логику встроенной:

  • в Redux Toolkit это становится редьюсером или thunk
  • в Zustand/Jotai/MobX/Valtio она живет в хранилище
  • для интеграции с сервером вы также можете вызывать ваш API из этого места

Учебники по управлению состоянием строятся на этом паттерне, этот пример лишь демонстрирует стартовую точку.

Массовые обновления с помощью data.batchSave

data.save — самый удобный входной пункт для захвата изменений пользователя, но у него есть один недостаток — авто-расписание: перетаскивание большого количества задач или другие тяжелые операции на больших проектах могут создавать сотни и тысячи изменений.

Если вы ожидаете, что так и будет для вашего приложения, вы можете переключиться в режим batch mode, передав вместо data.save data.batchSave. В этом режиме ReactGantt будет предоставлять вам сгруппированные изменения:

type GanttBatchChanges = {
tasks?: Array<DataCallbackChange<Task>>;
links?: Array<DataCallbackChange<Link>>;
resources?: Array<DataCallbackChange<Resource>>;
resourceAssignments?: Array<DataCallbackChange<ResourceAssignment>>;
};

interface DataCallbackChange<T> {
entity: string;
action: string;
data: T;
id: number | string;
}

Вот минимальный пример использования:

<ReactGantt
// ...props with tasks/links/resources etc.
data={{
batchSave: (changes) => {
console.log("Batch changes:", changes);

if (changes.tasks) {
setTasks((prev) => applyTaskBatch(prev, changes.tasks));
}

if (changes.links) {
setLinks((prev) => applyLinkBatch(prev, changes.links));
}

// Аналогично для resources / assignments, если требуется
},
}}
/>

Где applyTaskBatch/applyLinkBatch — небольшие помощники, которые проходят по { action, data, id } и возвращают обновленный массив.

По правилу большого пальца,

  • используйте batchSave, когда ожидаете много изменений за раз, и/или хотите отправить все изменения на бэкенд в одном запросе
  • используйте save, когда большинство правок относятся к одной задаче/ссылке и/или нужен максимально простой способ интеграции

Загрузка данных в состояние React

В управляемой React-моделью Gantt получает данные через состояние React. Откуда приходит это состояние, зависит от архитектуры вашего приложения.

Существует три распространённых способа заполнения состояния:

Локальное состояние компонента

Это полезно для быстрых демонстраций, прототипов или небольших приложений.

Данные часто поступают из локального сидера, но их также можно вычислять или получать выводом.

export default function GanttTemplatesDemo() {
const [tasks, setTasks] = useState(projectData.tasks);
const [links, setLinks] = useState(projectData.links);
const [resources, setResources] = useState(projectData.resources);
const [resourceAssignments, setResourceAssignments] =
useState(projectData.resourceAssignments);

return (
<div style={{height: '100vh'}}>
<ReactGantt
tasks={tasks}
links={links}
resources={resources}
resourceAssignments={resourceAssignments}
/>
</div>
);
};

Этот паттерн очень похож на использование менеджера состояния — единственное различие состоит в том, где хранится состояние.

Менеджеры состояний (Redux Toolkit, Zustand, MobX, Jotai, XState, Valtio)

Во многих продакшн-приложениях данные Gantt живут в глобальном хранилище, а не внутри компонента.

ReactGantt естественным образом интегрируется с этими библиотеками. Вы читаете данные из хранилища через селекторы или хуки хранилища и передаете их в <Gantt> как props, точно так же, как и с локальным состоянием.

Ниже приведены примеры того, как это обычно выглядит.

Redux Toolkit

const { tasks, links } = useSelector((state: RootState) => state.gantt);

Zustand

const tasks = useGanttStore((state) => state.tasks);

MobX

<Gantt tasks={store.tasks} links={store.links} />

Хотя у каждой библиотеки свой API, паттерн интеграции идентичен — вы передаете tasks, links, resources и т.п. как props, обрабатываете обновления через data.save или data.batchSave, единственное различие — откуда берется состояние.

Учебники по менеджерам состояния демонстрируют, как реализовать тот же паттерн в каждой конкретной библиотеке:

Загрузка данных из API

В реальных приложениях обычно данные загружаются из бэкенда и помещаются в состояние React (локальное или глобальное).

Ниже приведён более полный пример, который отражает типичное использование:

import { useEffect, useState } from "react";
import Gantt, {
Task,
Link,
Resource,
ResourceAssignment,
Calendar,
} from "@dhtmlx/trial-react-gantt";

interface GanttData {
tasks: Task[];
links: Link[];
resources: Resource[];
resourceAssignments: ResourceAssignment[];
}

export default function GanttWithApi() {
const [data, setData] = useState<GanttData | null>(null);
const [isLoading, setIsLoading] = useState(true);

useEffect(() => {
async function load() {
try {
const response = await fetch("/api/gantt-data");
const raw = await response.json();

const nextData: GanttData = {
tasks: raw.tasks,
links: raw.links,
resources: raw.resources ?? [],
resourceAssignments: raw.resourceAssignments ?? []
};

setData(nextData);
} finally {
setIsLoading(false);
}
}

load();
}, []);

if (isLoading || !data) {
return <div>Loading Gantt...</div>;
}

return (
<ReactGantt
tasks={data.tasks}
links={data.links}
resources={data.resources}
resourceAssignments={data.resourceAssignments}
data={{
save: (entity, action, item, id) => {
// Update state and sync with backend here
},
}}
/>
);
}

Этот подход красиво интегрируется с менеджерами состояний:

  • загрузка данных в эффекте или thunk,
  • сохранение в Redux/Zustand/MobX и т.д.,
  • передача в <Gantt> через props,
  • обработка обновлений с помощью save/batchSave.

Gantt как источник истины в React-приложении

Второй режим привязки — Gantt как источник истины, где Gantt (и при необходимости ваш бэкенд) рассматриваются как основной держатель данных.

React рендерит компонент, но не поддерживает задачу задач/ссылок/ресурсов как каноническое состояние, которое должно переходить в props после каждого обновления.

Эта модель полностью исключает цикл React state <-> Gantt.

Когда эта модель имеет смысл

Используйте Gantt как источник истины когда

  • наборы данных очень велики (тысячи задач)
  • авто-расписание или массовые обновления происходят часто
  • React не нужно реагировать на каждое обновление в реальном времени
  • страница в первую очередь ориентирована на "Gantt"

React остаётся ответственным за компоновку, маршрутизацию и окружающий UI, но Gantt владеет жизненным циклом данных.

Предоставление начальных данных

Даже в этой модели вы можете передать Gantt начальный набор данных. Ключевое различие в том, что вы не постоянно отражаете изменения обратно в состояние React.

Вы можете инициализировать Gantt любым из следующих подходов: загрузка данных по URL, загрузка данных через пользовательские функции, передача начального снимка через props. Подробности ниже.

Загрузка данных по URL

Gantt может загружать всё напрямую из вашего бэкенда через REST-эндпоинты:

<Gantt
data={{
load: "/api/gantt/load",
save: "/api/gantt/save",
}}
/>
  • data.load вызывается один раз при инициализации
  • data.save вызывается каждый раз, когда пользователь вносит изменения в tasks/links.

Загрузка данных через пользовательские функции

Вместо URL можно указать асинхронные функции:

<Gantt
data={{
load: async () => {
const res = await fetch("/api/gantt/load");
return res.json();
},
save: async (entity, action, item, id) => {
// см. пример ниже
},
}}
/>

Передача начального снимка через props (односторонний)

Вы по-прежнему можете передать начальные данные через props:

<Gantt tasks={initialTasks} links={initialLinks} />

В этом случае props служат лишь точкой старта. После инициализации Gantt поддерживает собственный внутренний хранилище и продолжает работу с него. Вы не повторно подаете новые массивы в props после каждого редактирования, потому что в этой модели React не считается каноничным владельцем данных.

Как работают обновления

Каждый раз, когда пользователи создают, редактируют или удаляют данные, Gantt вызывает колбэк save (или batchSave).

Gantt изначально присваивает временные ID создаваемым записям. Бэкенд должен заменить их на реальные идентификаторы базы данных.

Эта логика отражает поведение модуля DataProcessor в JS Gantt (см. Server-Side Integration в JS Docs).

Когда создаются новая задача, ссылка, ресурс или назначение, вызов save должен вернуть Promise, который разрешается в:

{ "id": "<database id>"}

Например:

data.save = async (entity, action, item, id) => {
if (action === "create") {
const response = await fetch(`/api/${entity}`, {
method: "POST",
body: JSON.stringify(item),
headers: { "Content-Type": "application/json" }
});

const result = await response.json();
// результат должен содержать { id: newDatabaseId }
return { id: result.id };
}

if (action === "update") {
await fetch(`/api/${entity}/${id}`, {
method: "PUT",
body: JSON.stringify(item),
headers: { "Content-Type": "application/json" }
});
return {};
}

if (action === "delete") {
await fetch(`/api/${entity}/${id}`, { method: "DELETE" });
return {};
}
};

Возврат {id: newId} позволяет Gantt заменить временный ID на постоянный. Это обеспечивает, что последующие обновления/удаления будут targeting нужной записи в вашей базе данных.

Использование batchSave

batchSave группирует несколько изменений в один колбэк. Так как несколько новых записей могут появиться одновременно, Gantt не ожидает, что batchSave что-то вернет.

При использовании batchSave необходимо создавать новые записи на бэкенде и получать их постоянные IDs и обновлять Gantt с помощью императивных вызовов API для замены временных ID:

gantt.changeTaskId(tempId, realId);
gantt.changeLinkId(tempId, realId);

Что дальше

После того как вы поняли две модели данных, можно переходить к конкретным урокам.

Менеджеры состояний:

Или узнайте больше об использовании императивного API и серверной коммуникации:

Need help?
Got a question about the documentation? Reach out to our technical support team for help and guidance. For custom component solutions, visit the Services page.